// BankAccount - a general bank account class
public class BankAccount
{
    // interest rate
    static private double m_dCurrentInterestRate;

    // balance - the current account's balance
    private double m_dBalance;

    // Rate - inquire or set interest rate
    public static double Rate()
    {
        return m_dCurrentInterestRate;
    }
    public static void Rate(double dNewRate)
    {
        // first a sanity check
        if (dNewRate > 0.0 && dNewRate < 20.0)
        {
            m_dCurrentInterestRate = dNewRate;
        }
    }

    // Deposit - add something to the account
    public void Deposit(double dAmount)
    {
        // no negative deposits!
        if (dAmount > 0.0)
        {
            m_dBalance += dAmount;
        }
    }

    // Withdrawal - take something out
    public void Withdrawal(double dAmount)
    {
        // negative withdrawals are a sneaky way
        // adding money to the account
        if (dAmount >= 0.0)
        {
            // don't let him withdraw more than he has
            if (dAmount <= m_dBalance)
            {
                m_dBalance -= dAmount;
            }
        }
    }

    // Balance - return the current balance rounded off to
    //           the nearest cent
    public double Balance()
    {
        int nCents = (int)(m_dBalance * 100 + 0.5);
        return nCents / 100.0;
    }

    // Monthly - each month wrack up interest and service
    //           fees
    public void Monthly()
    {
        Fee();     // fee first! (reduces interest we pay)
        Interest();
    }

    // Fee - wrack up the monthly fee
    public void Fee()
    {
        m_dBalance -= 5.0;   // $5.00 per month
    }

    // Interest - tack on monthly interest
    public void Interest()
    {
        // 1200 because interest is normally expressed
        // in numbers like 20% meaning .2 and because
        // we are accumulating interest monthly
        m_dBalance += m_dBalance *
                 (m_dCurrentInterestRate / 1200.0);
    }
}
